<template>
  <el-col :span="16" :offset="6">
    <el-form label-width="100px" ref="formRef" :model="form">
      <el-form-item
        label="技术员"
        prop="technicianId"
        style="margin-bottom: 20px"
        :rules="{
          required: true,
          message: '请选择',
          trigger: 'change'
        }"
        v-if="taskDefinitionKey == 'productionSupervisorApprove1'"
      >
        <el-select
          v-model="form.technicianId"
          clearable
          style="width: 100%"
          :filterable="true"
        >
          <el-option
            v-for="item in userOptions"
            :key="item.id"
            :label="item.name"
            :value="item.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item
        label="审批建议"
        prop="reason"
        style="margin-bottom: 20px"
        :rules="{
          required: true,
          message: '请选择',
          trigger: 'change'
        }"
      >
        <el-input
          type="textarea"
          v-model="form.reason"
          placeholder="请输入审批建议"
        />
      </el-form-item>
    </el-form>
    <div style="margin-left: 10%; margin-bottom: 20px; font-size: 14px">
      <el-button
        icon="el-icon-edit-outline"
        type="success"
        size="mini"
        @click="handleAudit(1)"
      >通过
      </el-button>
      <!-- <el-button
        icon="el-icon-edit-outline"
        type="success"
        size="mini"
        v-if="taskDefinitionKey === 'productionSupervisorApprove1'"
        @click="head"
        >指派技术员
      </el-button> -->
      <el-button
        icon="el-icon-circle-close"
        type="danger"
        size="mini"
        @click="handleAudit(0)"
        v-if="!['starter', 'salesmanApprove'].includes(taskDefinitionKey)"
      >驳回
      </el-button>

      <el-dropdown @command="(command) => handleCommand(command)" style="margin-left: 30px;">
        <span class="el-dropdown-link">更多<i class="el-icon-arrow-down el-icon--right"></i></span>
        <el-dropdown-menu slot="dropdown">
          <el-dropdown-item command="cancel">作废</el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>

      <!-- <el-button
        icon="el-icon-circle-close"
        type="danger"
        size="mini"
        @click="handleBackList"
        >退回
      </el-button> -->
      <!-- <el-button
        icon="el-icon-circle-close"
        type="danger"
        size="mini"
        @click="handleAudit(0)"
        v-if="taskDefinitionKey != 'productionSupervisorApprove1'"
        >不通过
      </el-button>
      <el-button
        icon="el-icon-edit-outline"
        type="primary"
        size="mini"
        v-if="taskDefinitionKey != 'productionSupervisorApprove1'"
        @click="handleUpdateAssignee"
        >转办
      </el-button> -->
    </div>
  </el-col>
</template>

<script>
import {
  updateProduct,
  UpdateInformation,
  cancel
} from '@/api/bpm/components/saleManage/businessOpportunity';
import {approveTaskWithVariables} from '@/api/bpm/task';
import {listAllUserBind} from '@/api/system/organization';
// 流程实例的详情页，可用于审批
export default {
  name: '',
  components: {},
  props: {
    businessId: {
      default: ''
    },
    taskId: {
      default: ''
    },
    id: {
      default: ''
    },
    taskDefinitionKey: {
      default: ''
    }
  },

  data() {
    return {
      form: {
        technicianId: '',
        reason: '',
        technicalAnswerName: ''
      },
      userOptions: []
    };
  },
  created() {
    this.userOptions = [];
    listAllUserBind().then((data) => {
      this.userOptions.push(...data);
    });
  },

  methods: {
    head() {
      this.$refs.headRef.open();
    },

    /** 处理转办审批人 */
    handleUpdateAssignee() {
      this.$emit('handleUpdateAssignee');
    },
    /** 退回 */
    handleBackList() {
      this.$emit('handleBackList');
    },

    async handleAudit(status) {
      if (this.taskDefinitionKey === 'starter') {
        let arr = await this.getTableValue();
        if (!arr) {
          return;
        }
        let data = await UpdateInformation(arr);
        if (data.code != '0') {
          return;
        }
      }
      //生产主管审批选择技术员
      if (
        this.taskDefinitionKey === 'productionSupervisorApprove1' &&
        status === 1
      ) {
        let data = await this.getTableValue();
        if (!this.form.technicianId) {
          this.$message.warning(`请选择技术人员！`);
          return;
        }
        let userIfon = this.userOptions.find(
          (item) => item.id == this.form.technicianId
        );
        let arr = data.map((item) => {
          return {
            ...item,
            id: item.id,
            produceDeliveryDeadline: item.produceDeliveryDeadline,
            technicalAnswerId: this.form.technicianId,
            technicalAnswerName: userIfon?.name
          };
        });

        if (!arr) {
          return;
        }

        await updateProduct(arr);
      }
      //生产主管2审批
      if (
        this.taskDefinitionKey === 'productionSupervisorApprove2' && status === 1) {
        let data = await this.getTableValue();
        let isProduceDeliveryDeadline = true;
        data.forEach((item) => {
          if (!item.produceDeliveryDeadline) {
            isProduceDeliveryDeadline = false;
          }
        });
        if (!isProduceDeliveryDeadline) {
          this.$message.warning(`请选择生产交付交期！`);
          return;
        }
      }
      //技术员修改
      if ((this.taskDefinitionKey === 'technicianApprove' || this.taskDefinitionKey === 'techLeaderApprove') && status === 1) {
        let data = await this.getTableValue();
        let requiredFiled = [
          {
            filed: 'singleWeight',
            name: '单重'
          }
        ]
        let list = []
        let arr = data.map((item) => {
          requiredFiled.forEach(i => {
            if (!item[i.filed]) {
              list.push(i.name)
            }
          })
          return {
            ...item,
            id: item.id,
            technicalDrawings: item.technicalDrawings || [],
            industryArtFiles: item.industryArtFiles || [],
            otherFiles: item.otherFiles || [],
            remark: item.remark,
            singleWeight: item.singleWeight,
            technicalParams: item.technicalParams,
            technicalAnswerId: item.technicalAnswerId,
            technicalAnswerName: item.technicalAnswerName
          };
        });
        console.log(arr);
        if (!arr) {
          return;
        }
        if (list.length) {
          return this.$message.warning('请输入' + list.join(','))
        }
        await updateProduct(arr);
      }
      //和销售主管审批
      if ((this.taskDefinitionKey === 'salesManagerApprove') && status === 1) {
        let arr = await this.getTableValue();

        let arrList = arr.map((item) => {
          return {
            ...item,
            id: item.id,
            singlePrice: item.singlePrice,
            totalCount: item.totalCount,
            totalPrice: item.totalPrice
          };
        }) || [];
        if (!arrList.length) {
          return;
        }
        await updateProduct(arrList);
      }
      //销售员补充
      if ((this.taskDefinitionKey === 'salesmanApprove') && status === 1) {
        let arr = await this.getTableValue();
        let singlePrice = true;
        let totalCount = true;
        let arrList = arr?.productList.map((item) => {
          if (!item.singlePrice) {
            singlePrice = false;
          }
          if (!item.totalCount) {
            totalCount = false;
          }
          return {
            ...item,
            id: item.id,
            singlePrice: item.singlePrice,
            totalCount: item.totalCount,
            totalPrice: item.totalPrice
          };
        }) || [];
        if (!singlePrice) {
          this.$message.warning(`请输入单价`);
          return;
        }
        if (!totalCount) {
          this.$message.warning(`请输入数量`);
          return;
        }
        if (!arrList.length) {
          return;
        }
        await updateProduct(arrList);
      }
      this._approveTaskWithVariables(status);
    },
    async _approveTaskWithVariables(status) {
      let variables = {
        pass: !!status
      };
      if (this.form.technicianId) {
        variables['technicianId'] = this.form.technicianId;
      }

      approveTaskWithVariables({
        id: this.taskId,
        reason: this.form.reason,
        variables
      }).then((res) => {
        if (res.data.code != '-1') {
          this.$emit('handleAudit', {
            status,
            title: status === 0 ? '驳回' : ''
          });
        }
      });
    },

    getTableValue() {
      return new Promise((resolve, reject) => {
        this.$emit('getTableValue', async (data) => {
          resolve(await data);
        });
      });
    },

    //更多
    handleCommand(command) {
      if (command === 'cancel') {
        this.$confirm("是否确认作废？", {
          type: 'warning',
          cancelButtonText: '取消',
          confirmButtonText: '确定'
        }).then(() => {
          cancel({
            id: this.taskId,
            reason: this.form.reason,
            businessId: this.businessId,
          }).then(() => {
            this.$emit('handleClose');
          }).catch(() => {
            this.$message.error("流程作废失败");
          });
        }).catch(() => {
        });
      }
    },

  }
};
</script>

<style lang="scss"></style>
